'This code is part of the book
'Microsoft Visual Basic .NET 2003 Kick Start
'
'THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
'EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF
'MERCHANTIBILITY AND/OR FITNESS FOR A PARTICULAR PURPOSE.
'
'Date: December, 2003
'Author: Erik Porter
'For more information or updates, visit http://www.duncanmackenzie.net
'Requires Visual Basic .NET 2003

Imports System.Data.SqlClient
Imports System.Configuration

Public Class Transactions
	Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

	Public Sub New()
		MyBase.New()

		'This call is required by the Windows Form Designer.
		InitializeComponent()

		'Add any initialization after the InitializeComponent() call

	End Sub

	'Form overrides dispose to clean up the component list.
	Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
		If disposing Then
			If Not (components Is Nothing) Then
				components.Dispose()
			End If
		End If
		MyBase.Dispose(disposing)
	End Sub

	'Required by the Windows Form Designer
	Private components As System.ComponentModel.IContainer

	'NOTE: The following procedure is required by the Windows Form Designer
	'It can be modified using the Windows Form Designer.  
	'Do not modify it using the code editor.
	Friend WithEvents lnkSuccess As System.Windows.Forms.LinkLabel
	Friend WithEvents lnkFailure As System.Windows.Forms.LinkLabel
	<System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
		Me.lnkSuccess = New System.Windows.Forms.LinkLabel
		Me.lnkFailure = New System.Windows.Forms.LinkLabel
		Me.SuspendLayout()
		'
		'lnkSuccess
		'
		Me.lnkSuccess.Anchor = System.Windows.Forms.AnchorStyles.None
		Me.lnkSuccess.LinkBehavior = System.Windows.Forms.LinkBehavior.HoverUnderline
		Me.lnkSuccess.Location = New System.Drawing.Point(42, 104)
		Me.lnkSuccess.Name = "lnkSuccess"
		Me.lnkSuccess.Size = New System.Drawing.Size(88, 32)
		Me.lnkSuccess.TabIndex = 0
		Me.lnkSuccess.TabStop = True
		Me.lnkSuccess.Text = "Perform Actions (Success)"
		Me.lnkSuccess.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
		'
		'lnkFailure
		'
		Me.lnkFailure.Anchor = System.Windows.Forms.AnchorStyles.None
		Me.lnkFailure.LinkBehavior = System.Windows.Forms.LinkBehavior.HoverUnderline
		Me.lnkFailure.Location = New System.Drawing.Point(162, 104)
		Me.lnkFailure.Name = "lnkFailure"
		Me.lnkFailure.Size = New System.Drawing.Size(88, 32)
		Me.lnkFailure.TabIndex = 1
		Me.lnkFailure.TabStop = True
		Me.lnkFailure.Text = "Perform Actions (Failure)"
		Me.lnkFailure.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
		'
		'Transactions
		'
		Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
		Me.ClientSize = New System.Drawing.Size(292, 266)
		Me.Controls.Add(Me.lnkFailure)
		Me.Controls.Add(Me.lnkSuccess)
		Me.Name = "Transactions"
		Me.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen
		Me.Text = "Transactions"
		Me.ResumeLayout(False)

	End Sub

#End Region

	Private Connection As SqlConnection
	Private Command1, Command2, Command3 As SqlCommand

	Private Sub lnkSuccess_LinkClicked(ByVal sender As System.Object, ByVal e As System.Windows.Forms.LinkLabelLinkClickedEventArgs) Handles lnkSuccess.LinkClicked
		Command2 = Nothing
		SetupDataObjects()
		ExecuteCommands()
	End Sub

	Private Sub lnkFailure_LinkClicked(ByVal sender As System.Object, ByVal e As System.Windows.Forms.LinkLabelLinkClickedEventArgs) Handles lnkFailure.LinkClicked
		SetupDataObjects()
		Command2.CommandText = "INSERT INTO Customers (CustomerID, ContactName) VALUES ('USER2', 'User 2')"
		ExecuteCommands()
	End Sub

	Private Sub SetupDataObjects()
		If Connection Is Nothing Then
			Connection = New SqlConnection(ConfigurationSettings.AppSettings("Northwind.ConnectionString"))
		End If

		If Command1 Is Nothing Then
			Command1 = New SqlCommand("INSERT INTO Customers (CustomerID, CompanyName, ContactName) VALUES ('USER1', 'User Company 1', 'User 1')", Connection)
		End If
		If Command2 Is Nothing Then
			Command2 = New SqlCommand("INSERT INTO Customers (CustomerID, CompanyName, ContactName) VALUES ('USER2', 'User Company 2', 'User 2')", Connection)
		End If
		If Command3 Is Nothing Then
			Command3 = New SqlCommand("INSERT INTO Customers (CustomerID, CompanyName, ContactName) VALUES ('USER3', 'User Company 3', 'User 3')", Connection)
		End If
	End Sub

	Private Sub ExecuteCommands()
		Dim MyTransaction As SqlTransaction

		Connection.Open()
		MyTransaction = Connection.BeginTransaction()

		Command1.Transaction = MyTransaction
		Command2.Transaction = MyTransaction
		Command3.Transaction = MyTransaction

		Try
			MessageBox.Show("Executing Command1...")
			Command1.ExecuteNonQuery()
			MessageBox.Show("Executing Command2...")
			Command2.ExecuteNonQuery()
			MessageBox.Show("Executing Command3...")
			Command3.ExecuteNonQuery()
			MyTransaction.Commit()
			MessageBox.Show("All Commands executed successfully!")
		Catch
			MyTransaction.Rollback()
			MessageBox.Show("There was an error!  All changes have been rolled back")
		Finally
			Connection.Close()
		End Try

	End Sub

End Class