'This code is part of the book
'Microsoft Visual Basic .NET 2003 Kick Start
'
'THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
'EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF
'MERCHANTIBILITY AND/OR FITNESS FOR A PARTICULAR PURPOSE.
'
'Date: December, 2003
'Author: Erik Porter
'For more information or updates, visit http://www.duncanmackenzie.net
'Requires Visual Basic .NET 2003

Imports System.Data.SqlClient
Imports System.Configuration

Public Class CustomersEditor
	Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

	Public Sub New()
		MyBase.New()

		'This call is required by the Windows Form Designer.
		InitializeComponent()

		'Add any initialization after the InitializeComponent() call

	End Sub

	'Form overrides dispose to clean up the component list.
	Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
		If disposing Then
			If Not (components Is Nothing) Then
				components.Dispose()
			End If
		End If
		MyBase.Dispose(disposing)
	End Sub

	'Required by the Windows Form Designer
	Private components As System.ComponentModel.IContainer

	'NOTE: The following procedure is required by the Windows Form Designer
	'It can be modified using the Windows Form Designer.  
	'Do not modify it using the code editor.
	Friend WithEvents btnSave As System.Windows.Forms.Button
	Friend WithEvents btnCancel As System.Windows.Forms.Button
	Friend WithEvents dgCustomers As System.Windows.Forms.DataGrid
	<System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
		Me.dgCustomers = New System.Windows.Forms.DataGrid
		Me.btnSave = New System.Windows.Forms.Button
		Me.btnCancel = New System.Windows.Forms.Button
		CType(Me.dgCustomers, System.ComponentModel.ISupportInitialize).BeginInit()
		Me.SuspendLayout()
		'
		'dgCustomers
		'
		Me.dgCustomers.Anchor = CType((((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom) _
					Or System.Windows.Forms.AnchorStyles.Left) _
					Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
		Me.dgCustomers.DataMember = ""
		Me.dgCustomers.HeaderForeColor = System.Drawing.SystemColors.ControlText
		Me.dgCustomers.Location = New System.Drawing.Point(8, 8)
		Me.dgCustomers.Name = "dgCustomers"
		Me.dgCustomers.Size = New System.Drawing.Size(536, 160)
		Me.dgCustomers.TabIndex = 0
		'
		'btnSave
		'
		Me.btnSave.Anchor = CType((System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
		Me.btnSave.Enabled = False
		Me.btnSave.Location = New System.Drawing.Point(344, 176)
		Me.btnSave.Name = "btnSave"
		Me.btnSave.Size = New System.Drawing.Size(96, 23)
		Me.btnSave.TabIndex = 1
		Me.btnSave.Text = "Save Changes"
		'
		'btnCancel
		'
		Me.btnCancel.Anchor = CType((System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Right), System.Windows.Forms.AnchorStyles)
		Me.btnCancel.Enabled = False
		Me.btnCancel.Location = New System.Drawing.Point(448, 176)
		Me.btnCancel.Name = "btnCancel"
		Me.btnCancel.Size = New System.Drawing.Size(96, 23)
		Me.btnCancel.TabIndex = 2
		Me.btnCancel.Text = "Cancel Changes"
		'
		'CustomersEditor
		'
		Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
		Me.ClientSize = New System.Drawing.Size(552, 206)
		Me.Controls.Add(Me.btnCancel)
		Me.Controls.Add(Me.btnSave)
		Me.Controls.Add(Me.dgCustomers)
		Me.Name = "CustomersEditor"
		Me.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen
		Me.Text = "Customers Editor"
		CType(Me.dgCustomers, System.ComponentModel.ISupportInitialize).EndInit()
		Me.ResumeLayout(False)

	End Sub

#End Region

	Private NorthwindCustomers As DataTable
	Private NorthwindCustomersAdapter As SqlDataAdapter

	Private Sub ProductEditor_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load
		SetupDataObjects()
		LoadData()
		dgCustomers.DataSource = NorthwindCustomers
		AddHandler NorthwindCustomers.RowChanged, AddressOf NorthwindChangesMade
		AddHandler NorthwindCustomers.RowDeleted, AddressOf NorthwindChangesMade
	End Sub

	Private Sub NorthwindChangesMade(ByVal sender As Object, ByVal e As DataRowChangeEventArgs)
		btnSave.Enabled = True
		btnCancel.Enabled = True
	End Sub

	Private Sub btnSave_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnSave.Click
		Try
			NorthwindCustomersAdapter.Update(NorthwindCustomers)
			LoadData()
			btnSave.Enabled = False
			btnCancel.Enabled = False
		Catch Ex As Exception
			MessageBox.Show(Ex.Message, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
		End Try
	End Sub

	Private Sub btnCancel_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnCancel.Click
		NorthwindCustomers.RejectChanges()
		btnSave.Enabled = False
		btnCancel.Enabled = False
	End Sub

	Private Sub SetupDataObjects()
		Dim NorthwindConnection As New SqlConnection(ConfigurationSettings.AppSettings("Northwind.ConnectionString"))
		NorthwindCustomers = New DataTable("Customers")
		NorthwindCustomersAdapter = New SqlDataAdapter("SELECT * FROM Customers ORDER BY ContactName", NorthwindConnection)
		With NorthwindCustomersAdapter
			.InsertCommand = New SqlCommand("INSERT INTO Customers (CustomerID, CompanyName, ContactName, ContactTitle, Address, City, Region, PostalCode, Country, Phone, Fax) VALUES (@CustomerID, @CompanyName, @ContactName, @ContactTitle, @Address, @City, @Region, @PostalCode, @Country, @Phone, @Fax)", NorthwindConnection)
			With .InsertCommand
				.Parameters.Add("@CustomerID", SqlDbType.NChar).SourceColumn = "CustomerID"
				.Parameters.Add("@CompanyName", SqlDbType.NVarChar).SourceColumn = "CompanyName"
				.Parameters.Add("@ContactName", SqlDbType.NVarChar).SourceColumn = "ContactName"
				.Parameters.Add("@ContactTitle", SqlDbType.NVarChar).SourceColumn = "ContactTitle"
				.Parameters.Add("@Address", SqlDbType.NVarChar).SourceColumn = "Address"
				.Parameters.Add("@City", SqlDbType.NVarChar).SourceColumn = "City"
				.Parameters.Add("@Region", SqlDbType.NVarChar).SourceColumn = "Region"
				.Parameters.Add("@PostalCode", SqlDbType.NVarChar).SourceColumn = "PostalCode"
				.Parameters.Add("@Country", SqlDbType.NVarChar).SourceColumn = "Country"
				.Parameters.Add("@Phone", SqlDbType.NVarChar).SourceColumn = "Phone"
				.Parameters.Add("@Fax", SqlDbType.NVarChar).SourceColumn = "Fax"
			End With
			.UpdateCommand = New SqlCommand("UPDATE Customers SET CompanyName = @CompanyName, ContactName = @ContactName, ContactTitle = @ContactTitle, Address = @Address, City = @City, Region = @Region, PostalCode = @PostalCode, Country = @Country, Phone = @Phone, Fax = @Fax WHERE CustomerID = @CustomerID", NorthwindConnection)
			With .UpdateCommand
				.Parameters.Add("@CustomerID", SqlDbType.NChar).SourceColumn = "CustomerID"
				.Parameters.Add("@CompanyName", SqlDbType.NVarChar).SourceColumn = "CompanyName"
				.Parameters.Add("@ContactName", SqlDbType.NVarChar).SourceColumn = "ContactName"
				.Parameters.Add("@ContactTitle", SqlDbType.NVarChar).SourceColumn = "ContactTitle"
				.Parameters.Add("@Address", SqlDbType.NVarChar).SourceColumn = "Address"
				.Parameters.Add("@City", SqlDbType.NVarChar).SourceColumn = "City"
				.Parameters.Add("@Region", SqlDbType.NVarChar).SourceColumn = "Region"
				.Parameters.Add("@PostalCode", SqlDbType.NVarChar).SourceColumn = "PostalCode"
				.Parameters.Add("@Country", SqlDbType.NVarChar).SourceColumn = "Country"
				.Parameters.Add("@Phone", SqlDbType.NVarChar).SourceColumn = "Phone"
				.Parameters.Add("@Fax", SqlDbType.NVarChar).SourceColumn = "Fax"
			End With
			.DeleteCommand = New SqlCommand("DELETE FROM Customers WHERE CustomerID = @CustomerID", NorthwindConnection)
			With .DeleteCommand
				.Parameters.Add("@CustomerID", SqlDbType.NChar).SourceColumn = "CustomerID"
			End With
		End With
	End Sub

	Private Sub LoadData()
		NorthwindCustomers.Rows.Clear()
		NorthwindCustomersAdapter.Fill(NorthwindCustomers)
	End Sub

End Class