Public Class Car
    Inherits Vehicle
    Dim m_Color As String
    Dim m_Make As String
    Dim m_Model As String
    Dim m_Year As Integer
    Dim m_Manufactured As Date
    Dim m_NumberOfTires As Integer
    Dim m_NumberOfDoors As Integer

    Public Property NumberOfTires() As Integer
        Get
            Return m_NumberOfTires
        End Get
        Set(ByVal Value As Integer)
            m_NumberOfTires = Value
        End Set
    End Property

    Public Property NumberOfDoors() As Integer
        Get
            Return m_NumberOfDoors
        End Get
        Set(ByVal Value As Integer)
            m_NumberOfDoors = Value
        End Set
    End Property


    Public Sub New()
        m_Manufactured = System.DateTime.Now()
    End Sub

    Public Sub New(ByVal Color As String)
        m_Manufactured = System.DateTime.Now
        m_Color = Color
    End Sub

    Public Sub New(ByVal dateManufactured As Date, _
        ByVal newColor As String)
        m_Manufactured = dateManufactured
        m_Color = newColor
    End Sub

    Public Sub DisplayInfo( _
        ByVal windowHeading As String)
        MsgBox(Me.Description)
    End Sub


    Public Property Manufactured() As Date
        Get
            Return m_Manufactured
        End Get
        Set(ByVal Value As Date)
            m_Manufactured = Value
        End Set
    End Property

    Public Function GetAge() As Long
        Dim days As Long
        Dim currentDate As Date
        currentDate = System.DateTime.Today
        days = currentDate.Subtract(m_Manufactured).Days
        Return days
    End Function


    Public Function GetAge(ByVal pointInTime As Date) As Long
        Dim days As Long
        days = pointInTime.Subtract(m_Manufactured).Days
        Return days
    End Function

    Public Function GetAge(ByVal unit As String) As Long
        Dim units As Long
        Dim current As Date
        Dim difference As System.TimeSpan
        current = System.DateTime.Today
        difference = current.Subtract(m_Manufactured)
        Select Case unit
            Case "Hours"
                units = difference.TotalHours

            Case "Days"
                units = difference.TotalDays

            Case "Minutes"
                units = difference.TotalMinutes

            Case "Years"
                units = difference.TotalDays \ 365
        End Select
        Return units
    End Function

    Public Shadows Function Description() As String
        Return String.Format("{0} {1} {2}", Year, Make, Model)
    End Function

    Public Property Year() As Integer
        Get
            Return m_Year
        End Get
        Set(ByVal Value As Integer)
            m_Year = Value
        End Set
    End Property


    Public Overrides Property Color() As String
        Get
            Return m_Color
        End Get
        Set(ByVal Value As String)
            Select Case Value.ToUpper()
                Case "RED"
                    m_Color = Value
                Case "YELLOW"
                    m_Color = Value
                Case "BLUE"
                    m_Color = Value
                Case Else
                    Dim objException As _
                      New System.ArgumentOutOfRangeException
                    Throw objException
            End Select
        End Set
    End Property

    Public Property Make() As String
        Get
            Return m_Make
        End Get
        Set(ByVal Value As String)
            m_Make = Value
        End Set
    End Property

    Public Property Model() As String
        Get
            Return m_Model
        End Get
        Set(ByVal Value As String)
            m_Model = Value
        End Set
    End Property



End Class


