Public Class Person
    Implements IComparable

    Private m_name As String
    Private m_firstName As String
    Private m_lastName As String

    Public ReadOnly Property DisplayName() As String
        Get
            Return String.Format("{0} {1}", _
                m_firstName, m_lastName)
        End Get
    End Property

    Public Property FirstName() As String
        Get
            Return m_firstName
        End Get
        Set(ByVal Value As String)
            m_firstName = Value
        End Set
    End Property

    Public Property LastName() As String
        Get
            Return m_lastName
        End Get
        Set(ByVal Value As String)
            m_lastName = Value
        End Set
    End Property

    Public Function CompareTo(ByVal obj As Object) As Integer _
             Implements System.IComparable.CompareTo
        'Compare this instance to obj, return a number
        'less than zero to indicate obj < me, 0 to indicate
        'obj = me, and greater than zero to indicate obj > me
        Dim objOtherPerson As Person
        If TypeOf obj Is Person Then
            objOtherPerson = DirectCast(obj, Person)
            If objOtherPerson.LastName < Me.LastName Then
                Return -1
            ElseIf objOtherPerson.LastName > Me.LastName Then
                Return 1
            Else
                If objOtherPerson.FirstName < Me.FirstName Then
                    Return -1
                ElseIf objOtherPerson.FirstName > Me.FirstName Then
                    Return 1
                Else
                    Return 0
                End If
            End If
        Else
            Throw New ArgumentException( _
                "CompareTo requires another Person object", "obj")
        End If
    End Function
End Class
