Imports System.Windows.Forms
Imports System.Globalization

Public Class NumericTextBox
    Inherits System.Windows.Forms.TextBox


    Protected Overrides Sub OnKeyPress( _
            ByVal e As KeyPressEventArgs)
        If Char.IsDigit(e.KeyChar) OrElse e.KeyChar = ","c _
            OrElse e.KeyChar = "."c OrElse _
            Char.GetUnicodeCategory(e.KeyChar) _
                = UnicodeCategory.Control OrElse _
            Char.GetUnicodeCategory(e.KeyChar) _
                = UnicodeCategory.CurrencySymbol _
            OrElse Char.GetUnicodeCategory(e.KeyChar) _
                = UnicodeCategory.Format Then
            e.Handled = False
        Else
            e.Handled = True
        End If
    End Sub
End Class



Public Class NullableDateTimePicker
    Inherits System.Windows.Forms.DateTimePicker

    Public Property NullableValue() As Object
        Get
            If MyBase.Checked Then
                Return DBNull.Value
            Else
                Return MyBase.Value
            End If
        End Get
        Set(ByVal Value As Object)
            If IsDBNull(Value) Then
                MyBase.Checked = True
            Else
                MyBase.Value = CDate(Value)
            End If
        End Set
    End Property
End Class
